//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation

public class ProfileCreationRequest: APIModel {

    /** The unique name of the profile. */
    public var name: String

    /** Whether an account pin is required to enter the profile.

If no account pin is defined this has no impact.
 */
    public var pinEnabled: Bool?

    /** Whether the profile can make purchases with the account payment options. */
    public var purchaseEnabled: Bool?

    /** The segments a profile should be placed under */
    public var segments: [String]?

    public init(name: String, pinEnabled: Bool? = nil, purchaseEnabled: Bool? = nil, segments: [String]? = nil) {
        self.name = name
        self.pinEnabled = pinEnabled
        self.purchaseEnabled = purchaseEnabled
        self.segments = segments
    }

    private enum CodingKeys: String, CodingKey {
        case name
        case pinEnabled
        case purchaseEnabled
        case segments
    }

    public required init(from decoder: Decoder) throws {
        let container = try decoder.container(keyedBy: CodingKeys.self)

        name = try container.decode(.name)
        pinEnabled = try container.decodeIfPresent(.pinEnabled)
        purchaseEnabled = try container.decodeIfPresent(.purchaseEnabled)
        segments = try container.decodeArrayIfPresent(.segments)
    }

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)

        try container.encode(name, forKey: .name)
        try container.encodeIfPresent(pinEnabled, forKey: .pinEnabled)
        try container.encodeIfPresent(purchaseEnabled, forKey: .purchaseEnabled)
        try container.encodeIfPresent(segments, forKey: .segments)
    }

    public func isEqual(to object: Any?) -> Bool {
      guard let object = object as? ProfileCreationRequest else { return false }
      guard self.name == object.name else { return false }
      guard self.pinEnabled == object.pinEnabled else { return false }
      guard self.purchaseEnabled == object.purchaseEnabled else { return false }
      guard self.segments == object.segments else { return false }
      return true
    }

    public static func == (lhs: ProfileCreationRequest, rhs: ProfileCreationRequest) -> Bool {
        return lhs.isEqual(to: rhs)
    }
}
