//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation

public class StreetSegment: APIModel {

    /** geoJSON formatted LineString containing two latitude/longitude (WGS84) pairs that identify the start and end points of the street segment. */
    public var lineString: String?

    /** The ID from the source system of the disruption that this street belongs to. */
    public var sourceSystemId: Int?

    /** The key of the source system of the disruption that this street belongs to. */
    public var sourceSystemKey: String?

    /** A 16 digit unique integer identifying a OS ITN (Ordnance Survey Integrated Transport Network) road link. */
    public var toid: String?

    public init(lineString: String? = nil, sourceSystemId: Int? = nil, sourceSystemKey: String? = nil, toid: String? = nil) {
        self.lineString = lineString
        self.sourceSystemId = sourceSystemId
        self.sourceSystemKey = sourceSystemKey
        self.toid = toid
    }

    private enum CodingKeys: String, CodingKey {
        case lineString
        case sourceSystemId
        case sourceSystemKey
        case toid
    }

    public required init(from decoder: Decoder) throws {
        let container = try decoder.container(keyedBy: CodingKeys.self)

        lineString = try container.decodeIfPresent(.lineString)
        sourceSystemId = try container.decodeIfPresent(.sourceSystemId)
        sourceSystemKey = try container.decodeIfPresent(.sourceSystemKey)
        toid = try container.decodeIfPresent(.toid)
    }

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)

        try container.encodeIfPresent(lineString, forKey: .lineString)
        try container.encodeIfPresent(sourceSystemId, forKey: .sourceSystemId)
        try container.encodeIfPresent(sourceSystemKey, forKey: .sourceSystemKey)
        try container.encodeIfPresent(toid, forKey: .toid)
    }

    public func isEqual(to object: Any?) -> Bool {
      guard let object = object as? StreetSegment else { return false }
      guard self.lineString == object.lineString else { return false }
      guard self.sourceSystemId == object.sourceSystemId else { return false }
      guard self.sourceSystemKey == object.sourceSystemKey else { return false }
      guard self.toid == object.toid else { return false }
      return true
    }

    public static func == (lhs: StreetSegment, rhs: StreetSegment) -> Bool {
        return lhs.isEqual(to: rhs)
    }
}
